---
title: Function expression
slug: Web/JavaScript/Reference/Operators/function
tags:
  - Function
  - JavaScript
  - Language feature
  - Operator
  - Primary Expressions
---
<div>{{jsSidebar("Operators")}}</div>

<p>The <strong><code>function</code></strong> keyword can be used to define a function inside an expression.</p>

<p>You can also define functions using the {{jsxref("Function/Function", "Function")}} constructor and a {{jsxref("Statements/function", "function declaration", "", 1)}}.</p>

<div>{{EmbedInteractiveExample("pages/js/expressions-functionexpression.html", "shorter")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<p>The expression is not allowed at the start of a statement.</p>

<pre class="syntaxbox">function [<var>name</var>]([<var>param1</var>[, <var>param2[</var>, ..., <var>paramN</var>]]]) {
   <var>statements</var>
}</pre>

<p>As of ES2015, you can also use {{jsxref("Functions/Arrow_functions", "arrow functions", "", 1)}}.</p>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>name</var></code> {{optional_inline}}</dt>
 <dd>The function name. Can be omitted, in which case the function is <em>anonymous</em>. The name is only local to the function body.</dd>
 <dt><code><var>paramN</var></code> {{optional_inline}}</dt>
 <dd>The name of an argument to be passed to the function.</dd>
 <dt><code><var>statements</var></code> {{optional_inline}}</dt>
 <dd>The statements which comprise the body of the function.</dd>
</dl>

<h2 id="Description">Description</h2>

<p>A function expression is very similar to and has almost the same syntax as a function declaration (see {{jsxref("Statements/function", "function")}} statement for details). The main difference between a function expression and a function declaration is the <em>function name</em>, which can be omitted in function expressions to create <em>anonymous</em> functions. A function expression can be used as an <a href="/en-US/docs/Glossary/IIFE">IIFE (Immediately Invoked Function Expression)</a> which runs as soon as it is defined. See also the chapter about {{jsxref("Functions", "functions", "", 1)}} for more information.</p>

<h3 id="Function_expression_hoisting">Function expression hoisting</h3>

<p>Function expressions in JavaScript are not hoisted, unlike {{jsxref("Statements/function", "function declarations", "#Function_declaration_hoisting", 1)}}. You can't use function expressions before you create them:</p>

<pre class="brush: js">console.log(notHoisted) // undefined
//  even though the variable name is hoisted, the definition isn't. so it's undefined.
notHoisted(); // TypeError: notHoisted is not a function

var notHoisted = function() {
   console.log('bar');
};
</pre>

<h3 id="Named_function_expression">Named function expression</h3>

<p>If you want to refer to the current function inside the function body, you need to create a named function expression. <u><strong>This name is then local only to the function body (scope)</strong></u>. This also avoids using the non-standard {{jsxref("Functions/arguments/callee", "arguments.callee")}} property.</p>

<pre class="brush: js">let math = {
  'factit': function factorial(n) {
    console.log(n)
    if (n &lt;= 1) {
      return 1;
    }
    return n * factorial(n - 1);
  }
};

math.factit(3) //3;2;1;
</pre>

<p>The variable the function expression is assigned to will have a <code>name</code> property. The name doesn't change if it's assigned to a different variable. If function name is omitted, it will be the variable name (implicit name). If function name is present, it will be the function name (explicit name). This also applies to {{jsxref("Functions/Arrow_functions", "arrow functions")}} (arrows don't have a name so you can only give the variable an implicit name).</p>

<pre class="brush: js">var foo = function() {}
foo.name // "foo"

var foo2 = foo
foo2.name // "foo"

var bar = function baz() {}
bar.name // "baz"

console.log(foo === foo2); // true
console.log(typeof baz); // undefined
console.log(bar === baz); // false (errors because baz == undefined)
</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Creating_an_unnamed_function">Creating an unnamed function</h3>

<p>The following example defines an unnamed function and assigns it to <code>x</code>. The function returns the square of its argument:</p>

<pre class="brush: js">var x = function(y) {
   return y * y;
};
</pre>

<h3 id="Using_a_function_as_a_callback">Using a function as a callback</h3>

<p>More commonly it is used as a {{Glossary("Callback_function", "callback")}}:</p>

<pre class="brush: js">button.addEventListener('click', function(event) {
    console.log('button is clicked!')
})
</pre>

<h3 id="Using_an_immediately_executed_function_expression">Using an immediately executed function expression</h3>

<p>An anonymous function is created and called:</p>

<pre class="brush: js">(function() {
    console.log('Code runs!')
})();
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-function-definitions', 'Function definitions')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.operators.function")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Arrow_functions", "Arrow functions", "", 1)}}</li>
 <li>{{jsxref("Functions_and_function_scope", "Functions and function scope", "", 1)}}</li>
 <li>{{jsxref("Function")}}</li>
 <li>{{jsxref("Statements/function", "function")}} statement</li>
 <li>{{jsxref("Statements/function*", "function*")}} statement</li>
 <li>{{jsxref("Operators/function*", "function*")}} expression</li>
 <li>{{jsxref("GeneratorFunction")}}</li>
 <li>{{jsxref("Statements/async_function", "async function", "", 1)}}</li>
 <li>{{jsxref("Operators/async_function", "async function expression", "", 1)}}</li>
</ul>
